#!/usr/bin/perl

package Domain;

sub new {
	my $class = shift;
	my $name = shift;

	my $self = { };

	$self->{name} = $name;
	bless $self, $class;
	return $self;
}

sub set_whois_server {
	my $self = shift;
	my $whois = shift;

	$self->{whois_server} = $whois;

	return $self;
}

sub get_whois_info {
	my $self = shift;

	die "No whois server" if (!exists $self->{whois_server});

	my $cmd = "whois $self->{name}\@$self->{whois_server}";
	if (!open(P, "$cmd|")) {
		die "Unable to open pipe to $cmd: $!";
	}

	my $have_data = 0;
	my $hr = { };

	while (<P>) {
		chomp;

		next if (/^%/);
		if (/^$/) {
			last if $have_data;
			next;
		}

		if (/^(\S+):\s+(.+)/) {
			push(@{$hr->{$1}}, $2);
			$have_data = 1;
		}
	}

	return $hr;
}

1;
