#!/usr/bin/perl

use HTML::TreeBuilder;

my $file = shift @ARGV;

my $tree = new HTML::TreeBuilder();

$tree->parse_file($file);

my $data_hr = { };

parse_1($data_hr, $tree);

if (%$data_hr) {
	print "Data returned:\n";

	foreach my $k (sort (keys %$data_hr)) {
		printf "%s: %s\n", $k, $data_hr->{$k};
	}
}

exit(0);

sub parse_1 {
	my $data_hr = shift;
	my $e = shift;

	# Be more detailed on certain types of things ...

	# Otherwise
	if (!ref $e) {
#		print "String: $e.\n";
		return;
	}

	my $tag = $e->tag();

	if ($tag eq 'form') {
		parse_form($data_hr, $e);
		return;
	}

#	print "Tag: $tag\n";

	my @list = $e->content_list();

	foreach (@list) {
		parse_1($data_hr, $_);
	}
}

sub parse_form {
	my $data_hr = shift;
	my $e = shift;

	# Be more detailed on certain types of things ...

	# Otherwise
	if (!ref $e) {
#		print "String: $e.\n";
		return;
	}

	my $tag = $e->tag();

	if ($tag eq 'input') {
		# Grab the field name and its current value
		my $name = $e->{name};
		my $value = $e->{value};

#		print "Found input tag: $name, $value\n";

		if ($name ne '') {
			$data_hr->{$name} = $value;
		}

		# I think this is right, input tags don't have any content
		return;
	}

	if ($tag eq 'select') {
		my $name = $e->{name};

		parse_select($data_hr, $name, $e);
		return;
	}

#	print "Tag: $tag\n";

	my @list = $e->content_list();

	foreach (@list) {
		parse_form($data_hr, $_);
	}
}

# parse_select($data_hr, $name, $e) ...

sub parse_select {
	my $data_hr = shift;
	my $name = shift;
	my $e = shift;

	if (!ref $e) {
		print "Oh oh, I didn't expect this: $e\n";
		return;
	}

	my $tag = $e->tag();

	if ($tag eq 'option') {
#		print "Option: ", ($e->content_list())[0], "\n";
		if ($e->{selected}) {
			my $value;

			# VALUE= attribute overrides content
			if (exists $e->{value}) {
				$value = $e->{value};
			} else {
				$value = ($e->content_list())[0];
			}
#			print "Found it ... $value\n";
			$data_hr->{$name} = $value;
		}

		# Don't recursively parse the content of an option
		return;
	}

	my @list = $e->content_list();

	foreach (@list) {
		parse_select($data_hr, $name, $_);
	}
}

